﻿using System;
using System.Diagnostics;
using System.Globalization;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;


namespace GPStoGoogleMapDesktop
{
	public partial class MainForm : Form
	{
		public MainForm()
		{
			InitializeComponent();
		}

		private void TestForm_Load(object sender, EventArgs e)
		{

		}

	
		private void BtnCloseClick(object sender, EventArgs e)
		{
			Close();
		}

		private void COWIButton_Click(object sender, EventArgs e)
		{
	
			Proj4Projection projTest = new Proj4Projection
			{
				InternalProjectionParametersString =
					Proj4Projection.GetEpsgParametersString(25832),
				ExternalProjectionParametersString =
					Proj4Projection.GetGoogleMapParametersString()
			};
			projTest.Open();

			try
			{
				var easting = Convert.ToDouble(textBox1.Text);
				var northing = Convert.ToDouble(textBox1.Text);
				var halfWidth = Convert.ToDouble(textBox3.Text) / 2;
				RectangleShape shape = new RectangleShape(easting - halfWidth, northing + halfWidth, easting + halfWidth, northing - halfWidth);


				var shapewidth = shape.Width;
				Debug.WriteLine("From original shape " + shapewidth);

				var shape2 = projTest.ConvertToInternalProjection(shape);

				Debug.WriteLine("From externalProjection " + shape2.Width);

				var shape3 = projTest.ConvertToExternalProjection(shape2);

				Debug.WriteLine("Back to internalProjection " + (shape3.Width));

				var shape2HalfWidth = shape2.Width/2;
				textBox4.Text = (shape2.LowerLeftPoint.X + shape2HalfWidth).ToString(CultureInfo.InvariantCulture);
				textBox5.Text = (shape2.LowerLeftPoint.Y + shape2HalfWidth).ToString(CultureInfo.InvariantCulture);
				textBox6.Text = shape2.Width.ToString(CultureInfo.InvariantCulture);

				var shape3HalfWidth = shape3.Width / 2;
				textBox7.Text = (shape3.LowerLeftPoint.X + shape3HalfWidth).ToString(CultureInfo.InvariantCulture);
				textBox8.Text = (shape3.LowerLeftPoint.Y + shape3HalfWidth).ToString(CultureInfo.InvariantCulture);
				textBox9.Text = shape3.Width.ToString(CultureInfo.InvariantCulture);
			}
			catch (Exception)
			{
				MessageBox.Show("Something went wrong. Check if input are valid numbers.");
			}
		}
	}

}
